searchData={"items":[{"type":"module","title":"IncidentIo","doc":"`IncidentIo` is an Elixir client for the Incident.io API.","ref":"IncidentIo.html"},{"type":"function","title":"IncidentIo.add_params_to_url/2","doc":"Take an existing URI and add addition params, appending and replacing as necessary.","ref":"IncidentIo.html#add_params_to_url/2"},{"type":"function","title":"Examples - IncidentIo.add_params_to_url/2","doc":"iex> add_params_to_url(\"http://example.com/wat\", [])\n    \"http://example.com/wat\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", [q: 1])\n    \"http://example.com/wat?q=1\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", [q: 1, t: 2])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", %{q: 1, t: 2})\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&t=2\", [])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1\", [t: 2])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1\", [q: 3, t: 2])\n    \"http://example.com/wat?q=3&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", [q: 3, t: 2])\n    \"http://example.com/wat?q=3&s=4&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", [q: 3, t: 2, u: [o: 1, v: 0]])\n    \"http://example.com/wat?q=3&s=4&t=2&u[o]=1&u[v]=0\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", [q: 3, t: 2, u: [1, \"two\", 3]])\n    \"http://example.com/wat?q=3&s=4&t=2&u[]=1&u[]=two&u[]=3\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", %{q: 3, t: 2})\n    \"http://example.com/wat?q=3&s=4&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", %{q: 3, t: 2, u: [o: 1, v: 0]})\n    \"http://example.com/wat?q=3&s=4&t=2&u[o]=1&u[v]=0\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", %{q: 3, t: 2, u: [1, \"two\", 3]})\n    \"http://example.com/wat?q=3&s=4&t=2&u[]=1&u[]=two&u[]=3\"","ref":"IncidentIo.html#add_params_to_url/2-examples"},{"type":"function","title":"IncidentIo.authorization_header/1","doc":"Same as `authorization_header/2` but defaults initial headers to include `@user_agent`.","ref":"IncidentIo.html#authorization_header/1"},{"type":"function","title":"IncidentIo.authorization_header/2","doc":"Use a JWT bearer token to authenticate to the Incident.io API:","ref":"IncidentIo.html#authorization_header/2"},{"type":"function","title":"Examples - IncidentIo.authorization_header/2","doc":"iex> IncidentIo.authorization_header(%{api_key: \"92873971893\"}, [])\n    [{\"Authorization\", \"Bearer 92873971893\"}]\n\nMore info at: https://api-docs.incident.io/#section/Making-requests/Authentication","ref":"IncidentIo.html#authorization_header/2-examples"},{"type":"function","title":"IncidentIo.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#delete/3"},{"type":"function","title":"IncidentIo.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#delete!/3"},{"type":"function","title":"IncidentIo.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#get/3"},{"type":"function","title":"IncidentIo.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#get!/3"},{"type":"function","title":"IncidentIo.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#head/3"},{"type":"function","title":"IncidentIo.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#head!/3"},{"type":"function","title":"IncidentIo.json_request/5","doc":"","ref":"IncidentIo.html#json_request/5"},{"type":"function","title":"IncidentIo.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#options/3"},{"type":"function","title":"IncidentIo.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#options!/3"},{"type":"function","title":"IncidentIo.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#patch/4"},{"type":"function","title":"IncidentIo.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#patch!/4"},{"type":"function","title":"IncidentIo.post/3","doc":"","ref":"IncidentIo.html#post/3"},{"type":"function","title":"IncidentIo.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#post/4"},{"type":"function","title":"IncidentIo.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#post!/4"},{"type":"function","title":"IncidentIo.process_headers/1","doc":"","ref":"IncidentIo.html#process_headers/1"},{"type":"function","title":"IncidentIo.process_request_body/1","doc":"","ref":"IncidentIo.html#process_request_body/1"},{"type":"function","title":"IncidentIo.process_request_headers/1","doc":"","ref":"IncidentIo.html#process_request_headers/1"},{"type":"function","title":"IncidentIo.process_request_options/1","doc":"","ref":"IncidentIo.html#process_request_options/1"},{"type":"function","title":"IncidentIo.process_request_params/1","doc":"","ref":"IncidentIo.html#process_request_params/1"},{"type":"function","title":"IncidentIo.process_request_url/1","doc":"","ref":"IncidentIo.html#process_request_url/1"},{"type":"function","title":"IncidentIo.process_response/1","doc":"","ref":"IncidentIo.html#process_response/1"},{"type":"function","title":"IncidentIo.process_response_body/1","doc":"","ref":"IncidentIo.html#process_response_body/1"},{"type":"function","title":"IncidentIo.process_response_chunk/1","doc":"","ref":"IncidentIo.html#process_response_chunk/1"},{"type":"function","title":"IncidentIo.process_response_headers/1","doc":"","ref":"IncidentIo.html#process_response_headers/1"},{"type":"function","title":"IncidentIo.process_response_status_code/1","doc":"","ref":"IncidentIo.html#process_response_status_code/1"},{"type":"function","title":"IncidentIo.process_status_code/1","doc":"","ref":"IncidentIo.html#process_status_code/1"},{"type":"function","title":"IncidentIo.process_url/1","doc":"","ref":"IncidentIo.html#process_url/1"},{"type":"function","title":"IncidentIo.put/3","doc":"","ref":"IncidentIo.html#put/3"},{"type":"function","title":"IncidentIo.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#put/4"},{"type":"function","title":"IncidentIo.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#put!/4"},{"type":"function","title":"IncidentIo.raw_request/5","doc":"","ref":"IncidentIo.html#raw_request/5"},{"type":"function","title":"IncidentIo.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"IncidentIo.html#request/1"},{"type":"function","title":"Redirect handling - IncidentIo.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"IncidentIo.html#request/1-redirect-handling"},{"type":"function","title":"Examples - IncidentIo.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"IncidentIo.html#request/1-examples"},{"type":"function","title":"IncidentIo.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"IncidentIo.html#request/5"},{"type":"function","title":"Redirect handling - IncidentIo.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"IncidentIo.html#request/5-redirect-handling"},{"type":"function","title":"Examples - IncidentIo.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"IncidentIo.html#request/5-examples"},{"type":"function","title":"IncidentIo.request!/1","doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"IncidentIo.html#request!/1"},{"type":"function","title":"IncidentIo.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"IncidentIo.html#request!/5"},{"type":"function","title":"IncidentIo.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"IncidentIo.html#start/0"},{"type":"function","title":"IncidentIo.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#stream_next/1"},{"type":"type","title":"IncidentIo.body/0","doc":"","ref":"IncidentIo.html#t:body/0"},{"type":"type","title":"IncidentIo.deprecated_incident_mode/0","doc":"","ref":"IncidentIo.html#t:deprecated_incident_mode/0"},{"type":"type","title":"IncidentIo.deprecated_incident_modes/0","doc":"","ref":"IncidentIo.html#t:deprecated_incident_modes/0"},{"type":"type","title":"IncidentIo.headers/0","doc":"","ref":"IncidentIo.html#t:headers/0"},{"type":"type","title":"IncidentIo.incident_mode/0","doc":"","ref":"IncidentIo.html#t:incident_mode/0"},{"type":"type","title":"IncidentIo.incident_modes/0","doc":"","ref":"IncidentIo.html#t:incident_modes/0"},{"type":"type","title":"IncidentIo.method/0","doc":"","ref":"IncidentIo.html#t:method/0"},{"type":"type","title":"IncidentIo.options/0","doc":"","ref":"IncidentIo.html#t:options/0"},{"type":"type","title":"IncidentIo.pagination_response/0","doc":"","ref":"IncidentIo.html#t:pagination_response/0"},{"type":"type","title":"IncidentIo.params/0","doc":"","ref":"IncidentIo.html#t:params/0"},{"type":"type","title":"IncidentIo.request/0","doc":"","ref":"IncidentIo.html#t:request/0"},{"type":"type","title":"IncidentIo.response/0","doc":"","ref":"IncidentIo.html#t:response/0"},{"type":"type","title":"IncidentIo.url/0","doc":"","ref":"IncidentIo.html#t:url/0"},{"type":"module","title":"IncidentIo.Client","doc":"Creates a HTTP client for interacting with the Incident.io API.","ref":"IncidentIo.Client.html"},{"type":"function","title":"IncidentIo.Client.new/0","doc":"","ref":"IncidentIo.Client.html#new/0"},{"type":"function","title":"IncidentIo.Client.new/1","doc":"","ref":"IncidentIo.Client.html#new/1"},{"type":"function","title":"IncidentIo.Client.new/2","doc":"","ref":"IncidentIo.Client.html#new/2"},{"type":"type","title":"IncidentIo.Client.auth/0","doc":"","ref":"IncidentIo.Client.html#t:auth/0"},{"type":"type","title":"IncidentIo.Client.t/0","doc":"","ref":"IncidentIo.Client.html#t:t/0"},{"type":"module","title":"IncidentIo.IdentityV1","doc":"Test if your API key is valid, and which roles it has.","ref":"IncidentIo.IdentityV1.html"},{"type":"function","title":"IncidentIo.IdentityV1.show/1","doc":"Get the identity associated with the API key used for the request.","ref":"IncidentIo.IdentityV1.html#show/1"},{"type":"function","title":"Example - IncidentIo.IdentityV1.show/1","doc":"IncidentIo.IdentityV1.show(client)\n\nMore information at: https://api-docs.incident.io/tag/Utilities-V1#operation/Utilities%20V1_Identity","ref":"IncidentIo.IdentityV1.html#show/1-example"},{"type":"module","title":"IncidentIo.IncidentRolesV2","doc":"Manage incident roles.\n\nDuring an incident, you can assign responders to one of the incident roles\nthat are configured in your organisation settings.\n\nEvery organisation will have a special 'lead' role, which signifies the\nincident lead or commander. This role cannot be deleted, but can be renamed in\nthe incident.io dashboard.","ref":"IncidentIo.IncidentRolesV2.html"},{"type":"function","title":"IncidentIo.IncidentRolesV2.create/2","doc":"Create a new incident role.\n\nIncident role body example:\n```elixir\n%{\n  description: \"The person currently coordinating the incident\",\n  instructions: \"Take point on the incident; Make sure people are clear on responsibilities\",\n  name: \"Incident Lead\",\n  shortform: \"lead\"\n}\n```","ref":"IncidentIo.IncidentRolesV2.html#create/2"},{"type":"function","title":"Example - IncidentIo.IncidentRolesV2.create/2","doc":"IncidentIo.IncidentRolesV2.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Roles-V2#operation/Incident-Roles%20V2_Create","ref":"IncidentIo.IncidentRolesV2.html#create/2-example"},{"type":"function","title":"IncidentIo.IncidentRolesV2.destroy/2","doc":"Removes an existing incident role.","ref":"IncidentIo.IncidentRolesV2.html#destroy/2"},{"type":"function","title":"Example - IncidentIo.IncidentRolesV2.destroy/2","doc":"IncidentIo.IncidentRolesV2.destroy(client, \"some-incident-role-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Roles-V2#operation/Incident-Roles%20V2_Delete","ref":"IncidentIo.IncidentRolesV2.html#destroy/2-example"},{"type":"function","title":"IncidentIo.IncidentRolesV2.list/1","doc":"List all incident roles for an organisation.","ref":"IncidentIo.IncidentRolesV2.html#list/1"},{"type":"function","title":"Example - IncidentIo.IncidentRolesV2.list/1","doc":"IncidentIo.IncidentRolesV2.list(client, \"some-incident-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Roles-V2#operation/Incident-Roles%20V2_List","ref":"IncidentIo.IncidentRolesV2.html#list/1-example"},{"type":"function","title":"IncidentIo.IncidentRolesV2.show/2","doc":"Get a single incident role.","ref":"IncidentIo.IncidentRolesV2.html#show/2"},{"type":"function","title":"Example - IncidentIo.IncidentRolesV2.show/2","doc":"IncidentIo.IncidentRolesV2.show(client, \"some-incident-role-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Roles-V2#operation/Incident-Roles%20V2_Show","ref":"IncidentIo.IncidentRolesV2.html#show/2-example"},{"type":"function","title":"IncidentIo.IncidentRolesV2.update/3","doc":"Update an existing incident role.\n\nIncident role body example:\n```elixir\n%{\n  description: \"The person currently coordinating the incident\",\n  instructions: \"Take point on the incident; Make sure people are clear on responsibilities\",\n  name: \"Incident Lead\",\n  shortform: \"lead\"\n}\n```","ref":"IncidentIo.IncidentRolesV2.html#update/3"},{"type":"function","title":"Example - IncidentIo.IncidentRolesV2.update/3","doc":"IncidentIo.IncidentRolesV2.update(client, \"some-incident-id\", body)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Roles-V2#operation/Incident-Roles%20V2_Update","ref":"IncidentIo.IncidentRolesV2.html#update/3-example"},{"type":"module","title":"IncidentIo.IncidentStatusesV1","doc":"Manage incident statuses.\n\nEach incident has a status, picked from one of the statuses configured in your\norganisation's settings.\n\nStatuses help communicate where an incident is in its lifecycle. You can use\nstatuses when filtering incidents in the dashboard, and in workflows and\nannouncement rules.","ref":"IncidentIo.IncidentStatusesV1.html"},{"type":"function","title":"IncidentIo.IncidentStatusesV1.create/2","doc":"Create a new incident status.\n\nincident status body example:\n```elixir\n%{\n  category: \"live\",\n  description: \"Impact has been **fully mitigated**, and we're ready to learn from this incident.\",\n  name: \"Closed\"\n}\n```","ref":"IncidentIo.IncidentStatusesV1.html#create/2"},{"type":"function","title":"Example - IncidentIo.IncidentStatusesV1.create/2","doc":"IncidentIo.IncidentStatusesV1.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Statuses-V1#operation/Incident-Statuses%20V1_Create","ref":"IncidentIo.IncidentStatusesV1.html#create/2-example"},{"type":"function","title":"IncidentIo.IncidentStatusesV1.destroy/2","doc":"Removes an existing incident status.","ref":"IncidentIo.IncidentStatusesV1.html#destroy/2"},{"type":"function","title":"Example - IncidentIo.IncidentStatusesV1.destroy/2","doc":"IncidentIo.IncidentStatusesV1.destroy(client, \"some-incident-status-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Statuses-V1#operation/Incident-Statuses%20V1_Delete","ref":"IncidentIo.IncidentStatusesV1.html#destroy/2-example"},{"type":"function","title":"IncidentIo.IncidentStatusesV1.list/1","doc":"List all incident statuses for an organisation.","ref":"IncidentIo.IncidentStatusesV1.html#list/1"},{"type":"function","title":"Example - IncidentIo.IncidentStatusesV1.list/1","doc":"IncidentIo.IncidentStatusesV1.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Statuses-V1#operation/Incident-Statuses%20V1_List","ref":"IncidentIo.IncidentStatusesV1.html#list/1-example"},{"type":"function","title":"IncidentIo.IncidentStatusesV1.show/2","doc":"Get a single incident status.","ref":"IncidentIo.IncidentStatusesV1.html#show/2"},{"type":"function","title":"Example - IncidentIo.IncidentStatusesV1.show/2","doc":"IncidentIo.IncidentStatusesV1.show(client, \"some-incident-status-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Statuses-V1#operation/Incident-Statuses%20V1_Show","ref":"IncidentIo.IncidentStatusesV1.html#show/2-example"},{"type":"function","title":"IncidentIo.IncidentStatusesV1.update/3","doc":"Update an existing incident status.\n\nincident status body example:\n```elixir\n%{\n  description: \"Impact has been **fully mitigated**, and we're ready to learn from this incident.\",\n  name: \"Closed\"\n}\n```","ref":"IncidentIo.IncidentStatusesV1.html#update/3"},{"type":"function","title":"Example - IncidentIo.IncidentStatusesV1.update/3","doc":"IncidentIo.IncidentStatusesV1.update(client, \"some-incident-status-id\", body)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Statuses-V1#operation/Incident-Statuses%20V1_Update","ref":"IncidentIo.IncidentStatusesV1.html#update/3-example"},{"type":"module","title":"IncidentIo.IncidentTimestampsV2","doc":"View incident timestamps.\n\nEach incident has a number of timestamps: some being defaults that we set on\neach incident for you, and others being configured for your organisation within\nsettings.\n\nTimestamps help to communicate when a given action was taken for a specific\nincident, for example when it was reported, closed or fixed.","ref":"IncidentIo.IncidentTimestampsV2.html"},{"type":"function","title":"IncidentIo.IncidentTimestampsV2.list/1","doc":"List all incident timestamps for an organisation.","ref":"IncidentIo.IncidentTimestampsV2.html#list/1"},{"type":"function","title":"Example - IncidentIo.IncidentTimestampsV2.list/1","doc":"IncidentIo.IncidentTimestampsV2.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Timestamps-V2#operation/Incident-Timestamps%20V2_List","ref":"IncidentIo.IncidentTimestampsV2.html#list/1-example"},{"type":"function","title":"IncidentIo.IncidentTimestampsV2.show/2","doc":"Get a single incident timestamp.","ref":"IncidentIo.IncidentTimestampsV2.html#show/2"},{"type":"function","title":"Example - IncidentIo.IncidentTimestampsV2.show/2","doc":"IncidentIo.IncidentTimestampsV2.show(client, \"some-incident-timestamp-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Timestamps-V2#operation/Incident-Timestamps%20V2_Show","ref":"IncidentIo.IncidentTimestampsV2.html#show/2-example"},{"type":"module","title":"IncidentIo.IncidentTypesV1","doc":"View incident types.\n\nWith incident types enabled, you can tailor your process to the situation\nyou're responding to with different custom fields and roles for each incident\ntype.","ref":"IncidentIo.IncidentTypesV1.html"},{"type":"function","title":"IncidentIo.IncidentTypesV1.list/1","doc":"List all incident types for an organisation.","ref":"IncidentIo.IncidentTypesV1.html#list/1"},{"type":"function","title":"Example - IncidentIo.IncidentTypesV1.list/1","doc":"IncidentIo.IncidentTypesV1.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Incident-Types-V1#operation/Incident%20Types%20V1_List","ref":"IncidentIo.IncidentTypesV1.html#list/1-example"},{"type":"function","title":"IncidentIo.IncidentTypesV1.show/2","doc":"Get a single incident type.","ref":"IncidentIo.IncidentTypesV1.html#show/2"},{"type":"function","title":"Example - IncidentIo.IncidentTypesV1.show/2","doc":"IncidentIo.IncidentTypesV1.show(client, \"some-incident-type-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incident-Types-V1#operation/Incident%20Types%20V1_Show","ref":"IncidentIo.IncidentTypesV1.html#show/2-example"},{"type":"module","title":"IncidentIo.IncidentsV1","doc":"Create and read incidents.\n\nIncidents are a core resource, on which many other resources (actions, etc)\nare created.\n\nCare should be taken around these endpoints, as automation that creates\nduplicate incidents can be distracting, and impact reporting.","ref":"IncidentIo.IncidentsV1.html"},{"type":"function","title":"IncidentIo.IncidentsV1.create/2","doc":"Create a new incident.\n\nincident body example:\n```elixir\n%{\n  category: \"live\",\n  description: \"Impact has been **fully mitigated**, and we're ready to learn from this incident.\",\n  name: \"Closed\"\n}\n```","ref":"IncidentIo.IncidentsV1.html#create/2"},{"type":"function","title":"Example - IncidentIo.IncidentsV1.create/2","doc":"IncidentIo.IncidentsV1.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V1#operation/Incidents%20V1_Create","ref":"IncidentIo.IncidentsV1.html#create/2-example"},{"type":"function","title":"IncidentIo.IncidentsV1.list/2","doc":"List all incidents for an organisation.","ref":"IncidentIo.IncidentsV1.html#list/2"},{"type":"function","title":"Example - IncidentIo.IncidentsV1.list/2","doc":"IncidentIo.IncidentsV1.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V1#operation/Incidents%20V1_List","ref":"IncidentIo.IncidentsV1.html#list/2-example"},{"type":"function","title":"IncidentIo.IncidentsV1.show/2","doc":"Get a single incident.","ref":"IncidentIo.IncidentsV1.html#show/2"},{"type":"function","title":"Example - IncidentIo.IncidentsV1.show/2","doc":"IncidentIo.IncidentsV1.show(client, \"some-incident-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V1#operation/Incidents%20V1_Show","ref":"IncidentIo.IncidentsV1.html#show/2-example"},{"type":"module","title":"IncidentIo.IncidentsV2","doc":"Create and read incidents.\n\nIncidents are a core resource, on which many other resources (actions, etc)\nare created.\n\nCare should be taken around these endpoints, as automation that creates\nduplicate incidents can be distracting, and impact reporting.","ref":"IncidentIo.IncidentsV2.html"},{"type":"function","title":"IncidentIo.IncidentsV2.create/2","doc":"Create a new incident.\n\nIncident body example:\n```elixir\n%{\n  custom_field_entries: [\n    %{\n      custom_field_id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n      values: [\n        %{\n          id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n          value_catalog_entry_id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n          value_link: \"https://google.com/\",\n          value_numeric: \"123.456\",\n          value_option_id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n          value_text: \"This is my text field, I hope you like it\",\n          value_timestamp: \"\"\n        }\n      ]\n    }\n  ],\n  id: \"01FDAG4SAP5TYPT98WGR2N7W91\",\n  idempotency_key: \"alert-uuid\",\n  incident_role_assignments: [\n    %{\n      assignee: %{\n        email: \"bob@example.com\",\n        id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n        slack_user_id: \"USER123\"\n      },\n      incident_role_id: \"01FH5TZRWMNAFB0DZ23FD1TV96\"\n    }\n  ],\n  incident_status_id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n  incident_timestamp_values: [\n    %{\n      incident_timestamp_id: \"01FCNDV6P870EA6S7TK1DSYD5H\",\n      value: \"2021-08-17T13:28:57.801578Z\"\n    }\n  ],\n  incident_type_id: \"01FH5TZRWMNAFB0DZ23FD1TV96\",\n  mode: \"standard\",\n  name: \"Our database is sad\",\n  retrospective_incident_options: %{\n    postmortem_document_url: \"https://docs.google.com/my_doc_id\",\n    slack_channel_id: \"abc123\"\n  },\n  severity_id: \"01FH5TZRWMNAFB0DZ23FD1TV96\",\n  slack_channel_name_override: \"inc-123-database-down\",\n  slack_team_id: \"T02A1FSLE8J\",\n  summary: \"Our database is really really sad, and we don't know why yet.\",\n  visibility: \"public\"\n}\n```","ref":"IncidentIo.IncidentsV2.html#create/2"},{"type":"function","title":"Example - IncidentIo.IncidentsV2.create/2","doc":"IncidentIo.IncidentsV2.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V2#operation/Incidents%20V2_Create","ref":"IncidentIo.IncidentsV2.html#create/2-example"},{"type":"function","title":"IncidentIo.IncidentsV2.list/2","doc":"List all incidents for an organisation.","ref":"IncidentIo.IncidentsV2.html#list/2"},{"type":"function","title":"Example - IncidentIo.IncidentsV2.list/2","doc":"IncidentIo.IncidentsV2.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V2#operation/Incidents%20V2_List","ref":"IncidentIo.IncidentsV2.html#list/2-example"},{"type":"function","title":"IncidentIo.IncidentsV2.show/2","doc":"Get a single incident.","ref":"IncidentIo.IncidentsV2.html#show/2"},{"type":"function","title":"Example - IncidentIo.IncidentsV2.show/2","doc":"IncidentIo.IncidentsV2.show(client, \"some-incident-id\")\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V2#operation/Incidents%20V2_Show","ref":"IncidentIo.IncidentsV2.html#show/2-example"},{"type":"function","title":"IncidentIo.IncidentsV2.update/3","doc":"Update an existing incident.\n\nIncident body example:\n```elixir\n%{\n  incident: %{\n    call_url: \"https://zoom.us/foo\",\n    custom_field_entries: [\n      %{\n        custom_field_id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n        values: [\n          %{\n            id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n            value_catalog_entry_id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n            value_link: \"https://google.com/\",\n            value_numeric: \"123.456\",\n            value_option_id: \"01FCNDV6P870EA6S7TK1DSYDG0\",\n            value_text: \"This is my text field, I hope you like it\",\n            value_timestamp: \"\"\n          }\n        ]\n      }\n    ],\n    incident_role_assignments: [\n      %{\n        assignee: %{\n          email: \"bob@example.com\",\n          id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n          slack_user_id: \"USER123\"\n        },\n        incident_role_id: \"01FH5TZRWMNAFB0DZ23FD1TV96\"\n      }\n    ],\n    incident_status_id: \"01FH5TZRWMNAFB0DZ23FD1TV96\",\n    incident_timestamp_values: [\n      %{\n        incident_timestamp_id: \"01FCNDV6P870EA6S7TK1DSYD5H\",\n        value: \"2021-08-17T13:28:57.801578Z\"\n      }\n    ],\n    name: \"Our database is sad\",\n    severity_id: \"01FH5TZRWMNAFB0DZ23FD1TV96\",\n    summary: \"Our database is really really sad, and we don't know why yet.\"\n  },\n  notify_incident_channel: true\n}\n```","ref":"IncidentIo.IncidentsV2.html#update/3"},{"type":"function","title":"Example - IncidentIo.IncidentsV2.update/3","doc":"IncidentIo.IncidentsV2.update(client, \"some-incident-id\", body)\n\nMore information at: https://api-docs.incident.io/tag/Incidents-V2#operation/Incidents%20V2_Update","ref":"IncidentIo.IncidentsV2.html#update/3-example"},{"type":"module","title":"IncidentIo.OpenApiV1","doc":"Test if your API key is valid, and which roles it has.","ref":"IncidentIo.OpenApiV1.html"},{"type":"function","title":"IncidentIo.OpenApiV1.show/2","doc":"Get the OpenAPI specification for the Incident.io API.","ref":"IncidentIo.OpenApiV1.html#show/2"},{"type":"function","title":"Example - IncidentIo.OpenApiV1.show/2","doc":"IncidentIo.OpenApiV1.show(client)\n\n    IncidentIo.OpenApiV1.show(client, 2)\n\nMore information at: https://api-docs.incident.io/tag/Utilities-V1#operation/Utilities%20V1_OpenAPIV3","ref":"IncidentIo.OpenApiV1.html#show/2-example"},{"type":"module","title":"IncidentIo.Query","doc":"Conveniences for decoding and encoding URL-encoded queries.\n\nPlug allows developers to build query strings that map to\nElixir structures in order to make manipulation of such structures\neasier on the server side. Here are some examples:\n\n    iex> decode(\"foo=bar\")[\"foo\"]\n    \"bar\"\n\nIf a value is given more than once, the last value takes precedence:\n\n    iex> decode(\"foo=bar&foo=baz\")[\"foo\"]\n    \"baz\"\n\nNested structures can be created via `[key]`:\n\n    iex> decode(\"foo[bar]=baz\")[\"foo\"][\"bar\"]\n    \"baz\"\n\nLists are created with `[]`:\n\n    iex> decode(\"foo[]=bar&foo[]=baz\")[\"foo\"]\n    [\"bar\", \"baz\"]\n\n> #### Nesting inside lists {: .error}\n>\n> Nesting inside lists is ambiguous and unspecified behaviour.\n> Therefore, you should not rely on the decoding behaviour of\n> `user[][foo]=1&user[][bar]=2`.\n>\n> As an alternative, you can explicitly specify the keys:\n>\n>     # If foo and bar belong to the same entry\n>     user[0][foo]=1&user[0][bar]=2\n>\n>     # If foo and bar are different entries\n>     user[0][foo]=1&user[1][bar]=2\n\nKeys without values are treated as empty strings,\naccording to https://url.spec.whatwg.org/#application/x-www-form-urlencoded:\n\n    iex> decode(\"foo\")[\"foo\"]\n    \"\"\n\nMaps can be encoded:\n\n    iex> encode(%{foo: \"bar\"})\n    \"foo=bar\"\n\nEncoding keyword lists preserves the order of the fields:\n\n    iex> encode([foo: \"bar\", baz: \"bat\"])\n    \"foo=bar&baz=bat\"\n\nWhen encoding keyword lists with duplicate keys, the key that comes first\ntakes precedence:\n\n    iex> encode([foo: \"bar\", foo: \"bat\"])\n    \"foo=bar\"\n\nEncoding named lists:\n\n    iex> encode(%{foo: [\"bar\", \"baz\"]})\n    \"foo[]=bar&foo[]=baz\"\n\nEncoding nested structures:\n\n    iex> encode(%{foo: %{bar: \"baz\"}})\n    \"foo[bar]=baz\"\n\nIt is only possible to encode maps inside lists if those maps have exactly one element.\nIn this case it is possible to encode the parameters using maps instead of lists:\n\n    iex> encode(%{\"list\" => [%{\"a\" => 1, \"b\" => 2}]})\n    ** (ArgumentError) cannot encode maps inside lists when the map has 0 or more than 1 element, got: %{\"a\" => 1, \"b\" => 2}\n\n    iex> encode(%{\"list\" => %{0 => %{\"a\" => 1, \"b\" => 2}}})\n    \"list[0][a]=1&list[0][b]=2\"\n\nFor stateful decoding, see `decode_init/0`, `decode_each/2`, and `decode_done/2`.","ref":"IncidentIo.Query.html"},{"type":"function","title":"IncidentIo.Query.decode/2","doc":"Decodes the given `query`.\n\nThe `query` is assumed to be encoded in the \"x-www-form-urlencoded\" format.\n\n`initial` is the initial \"accumulator\" where decoded values will be added.","ref":"IncidentIo.Query.html#decode/2"},{"type":"function","title":"IncidentIo.Query.decode_done/2","doc":"Finishes stateful decoding and returns a map with the decoded pairs.\n\n`decoder` is the stateful decoder returned by `decode_init/0` and `decode_each/2`.\n`initial` is an enumerable of key-value pairs that functions as the initial\naccumulator for the returned map (see examples below).","ref":"IncidentIo.Query.html#decode_done/2"},{"type":"function","title":"Examples - IncidentIo.Query.decode_done/2","doc":"iex> decoder = IncidentIo.Query.decode_init()\n    iex> decoder = IncidentIo.Query.decode_each({\"foo\", \"bar\"}, decoder)\n    iex> IncidentIo.Query.decode_done(decoder, %{\"initial\" => true})\n    %{\"foo\" => \"bar\", \"initial\" => true}","ref":"IncidentIo.Query.html#decode_done/2-examples"},{"type":"function","title":"IncidentIo.Query.decode_each/2","doc":"Decodes the given `pair` tuple.\n\nIt parses the key and stores the value into the current\naccumulator `decoder`. The keys and values are not assumed to be\nencoded in `\"x-www-form-urlencoded\"`.","ref":"IncidentIo.Query.html#decode_each/2"},{"type":"function","title":"Examples - IncidentIo.Query.decode_each/2","doc":"iex> decoder = IncidentIo.Query.decode_init()\n    iex> decoder = IncidentIo.Query.decode_each({\"foo\", \"bar\"}, decoder)\n    iex> decoder = IncidentIo.Query.decode_each({\"baz\", \"bat\"}, decoder)\n    iex> IncidentIo.Query.decode_done(decoder)\n    %{\"baz\" => \"bat\", \"foo\" => \"bar\"}","ref":"IncidentIo.Query.html#decode_each/2-examples"},{"type":"function","title":"IncidentIo.Query.decode_init/0","doc":"Starts a stateful decoder.\n\nUse `decode_each/2` and `decode_done/2` to decode and complete.\nSee `decode_each/2` for examples.","ref":"IncidentIo.Query.html#decode_init/0"},{"type":"function","title":"IncidentIo.Query.encode/2","doc":"Encodes the given map or list of tuples.","ref":"IncidentIo.Query.html#encode/2"},{"type":"opaque","title":"IncidentIo.Query.decoder/0","doc":"Stateful decoder accumulator.\n\nSee `decode_init/0`, `decode_each/2`, and `decode_done/2`.","ref":"IncidentIo.Query.html#t:decoder/0"},{"type":"module","title":"IncidentIo.ScheduleEntriesV2","doc":"Read schedule entries.","ref":"IncidentIo.ScheduleEntriesV2.html"},{"type":"function","title":"IncidentIo.ScheduleEntriesV2.list/3","doc":"Get a list of schedule entries.","ref":"IncidentIo.ScheduleEntriesV2.html#list/3"},{"type":"function","title":"Example - IncidentIo.ScheduleEntriesV2.list/3","doc":"IncidentIo.ScheduleEntriesV2.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Schedules-V2#operation/Schedules%20V2_ListScheduleEntries","ref":"IncidentIo.ScheduleEntriesV2.html#list/3-example"},{"type":"module","title":"IncidentIo.SchedulesV2","doc":"List configured schedules.","ref":"IncidentIo.SchedulesV2.html"},{"type":"function","title":"IncidentIo.SchedulesV2.create/2","doc":"Create a new schedule.\n\nSchedule body example:\n```elixir\n%{\n  schedule: %{\n    annotations: %{\n      \"incident.io/terraform/version\": \"version-of-terraform\"\n    },\n    config: %{\n      rotations: [\n        %{\n          effective_from: \"2021-08-17T13:28:57.801578Z\",\n          handover_start_at: \"2021-08-17T13:28:57.801578Z\",\n          handovers: [\n            %{\n              interval: 1,\n              interval_type: \"daily\"\n            }\n          ],\n          id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n          layers: [\n            %{\n              id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n              name: \"Layer 1\"\n            }\n          ],\n          name: \"My Rotation\",\n          users: [\n            %{\n              email: \"bob@example.com\",\n              id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n              slack_user_id: \"USER123\"\n            }\n          ],\n          working_interval: [\n            %{\n              end_time: \"17:00\",\n              start_time: \"09:00\",\n              weekday: \"tuesday\"\n            }\n          ]\n        }\n      ]\n    },\n    name: \"My Schedule\",\n    timezone: \"America/Los_Angeles\"\n  }\n}\n```","ref":"IncidentIo.SchedulesV2.html#create/2"},{"type":"function","title":"Example - IncidentIo.SchedulesV2.create/2","doc":"IncidentIo.SchedulesV2.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Schedules-V2#operation/Schedules%20V2_Create","ref":"IncidentIo.SchedulesV2.html#create/2-example"},{"type":"function","title":"IncidentIo.SchedulesV2.destroy/2","doc":"Archives a single schedule.","ref":"IncidentIo.SchedulesV2.html#destroy/2"},{"type":"function","title":"Example - IncidentIo.SchedulesV2.destroy/2","doc":"IncidentIo.SchedulesV2.destroy(client, \"some-schedule-id\")\n\nMore information at: https://api-docs.incident.io/tag/Schedules-V2#operation/Schedules%20V2_Destroy","ref":"IncidentIo.SchedulesV2.html#destroy/2-example"},{"type":"function","title":"IncidentIo.SchedulesV2.list/2","doc":"Get a list of schedules.","ref":"IncidentIo.SchedulesV2.html#list/2"},{"type":"function","title":"Example - IncidentIo.SchedulesV2.list/2","doc":"IncidentIo.SchedulesV2.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Schedules-V2#operation/Schedules%20V2_List","ref":"IncidentIo.SchedulesV2.html#list/2-example"},{"type":"function","title":"IncidentIo.SchedulesV2.show/2","doc":"Get a single schedule.","ref":"IncidentIo.SchedulesV2.html#show/2"},{"type":"function","title":"Example - IncidentIo.SchedulesV2.show/2","doc":"IncidentIo.SchedulesV2.show(client, \"some-schedule-id\")\n\nMore information at: https://api-docs.incident.io/tag/Schedules-V2#operation/Schedules%20V2_Show","ref":"IncidentIo.SchedulesV2.html#show/2-example"},{"type":"function","title":"IncidentIo.SchedulesV2.update/3","doc":"Update a schedule.\n\nSchedule body example:\n```elixir\n%{\n  schedule: %{\n    annotations: %{\n      \"incident.io/terraform/version\": \"version-of-terraform\"\n    },\n    config: %{\n      rotations: [\n        %{\n          effective_from: \"2021-08-17T13:28:57.801578Z\",\n          handover_start_at: \"2021-08-17T13:28:57.801578Z\",\n          handovers: [\n            %{\n              interval: 1,\n              interval_type: \"daily\"\n            }\n          ],\n          id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n          layers: [\n            %{\n              id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n              name: \"Layer 1\"\n            }\n          ],\n          name: \"My Rotation\",\n          users: [\n            %{\n              email: \"bob@example.com\",\n              id: \"01G0J1EXE7AXZ2C93K61WBPYEH\",\n              slack_user_id: \"USER123\"\n            }\n          ],\n          working_interval: [\n            %{\n              end_time: \"17:00\",\n              start_time: \"09:00\",\n              weekday: \"tuesday\"\n            }\n          ]\n        }\n      ]\n    },\n    name: \"My Schedule\",\n    timezone: \"America/Los_Angeles\"\n  }\n}\n```","ref":"IncidentIo.SchedulesV2.html#update/3"},{"type":"function","title":"Example - IncidentIo.SchedulesV2.update/3","doc":"IncidentIo.SchedulesV2.update(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Schedules-V2#operation/Schedules%20V2_Update","ref":"IncidentIo.SchedulesV2.html#update/3-example"},{"type":"module","title":"IncidentIo.SeveritiesV1","doc":"Manage severities.\n\nEach incident has a severity, picked from one of the severities configured in\nyour organisation's settings.\n\nSeverities help categorise incidents, and communicate urgency/impact. You can\nuse severities when filtering incidents in the dashboard, and in workflows and\nannouncement rules.","ref":"IncidentIo.SeveritiesV1.html"},{"type":"function","title":"IncidentIo.SeveritiesV1.create/2","doc":"Create a new severity.\n\nSeverity body example:\n```elixir\n%{\n  description: \"Issues with **low impact**.\",\n  name: \"Minor\",\n  rank: 1\n}\n```","ref":"IncidentIo.SeveritiesV1.html#create/2"},{"type":"function","title":"Example - IncidentIo.SeveritiesV1.create/2","doc":"IncidentIo.SeveritiesV1.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Severities-V1#operation/Severities%20V1_Create","ref":"IncidentIo.SeveritiesV1.html#create/2-example"},{"type":"function","title":"IncidentIo.SeveritiesV1.destroy/2","doc":"Delete an existing severity.","ref":"IncidentIo.SeveritiesV1.html#destroy/2"},{"type":"function","title":"Example - IncidentIo.SeveritiesV1.destroy/2","doc":"IncidentIo.SeveritiesV1.destroy(client, \"some-severity-id\")\n\nMore information at: https://api-docs.incident.io/tag/Severities-V1#operation/Severities%20V1_Delete","ref":"IncidentIo.SeveritiesV1.html#destroy/2-example"},{"type":"function","title":"IncidentIo.SeveritiesV1.list/1","doc":"List all severities for an organisation.","ref":"IncidentIo.SeveritiesV1.html#list/1"},{"type":"function","title":"Example - IncidentIo.SeveritiesV1.list/1","doc":"IncidentIo.SeveritiesV1.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Severities-V1#operation/Severities%20V1_List","ref":"IncidentIo.SeveritiesV1.html#list/1-example"},{"type":"function","title":"IncidentIo.SeveritiesV1.show/2","doc":"Get a single severity.","ref":"IncidentIo.SeveritiesV1.html#show/2"},{"type":"function","title":"Example - IncidentIo.SeveritiesV1.show/2","doc":"IncidentIo.SeveritiesV1.show(client, \"some-severity-id\")\n\nMore information at: https://api-docs.incident.io/tag/Severities-V1#operation/Severities%20V1_Show","ref":"IncidentIo.SeveritiesV1.html#show/2-example"},{"type":"function","title":"IncidentIo.SeveritiesV1.update/3","doc":"Update an existing severity.\n\nSchedule body example:\n```elixir\n%{\n  description: \"Issues with **low impact**.\",\n  name: \"Morris Minor\",\n  rank: 2\n}\n```","ref":"IncidentIo.SeveritiesV1.html#update/3"},{"type":"function","title":"Example - IncidentIo.SeveritiesV1.update/3","doc":"IncidentIo.SeveritiesV1.update(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Severities-V1#operation/Severities%20V1_Update","ref":"IncidentIo.SeveritiesV1.html#update/3-example"},{"type":"module","title":"IncidentIo.UsersV2","doc":"View users.\n\nUsers all have a single base role, and can be assigned multiple custom roles.\nThey can be managed via your Slack workspace or SAML provider.","ref":"IncidentIo.UsersV2.html"},{"type":"function","title":"IncidentIo.UsersV2.list/2","doc":"List users for an organisation.","ref":"IncidentIo.UsersV2.html#list/2"},{"type":"function","title":"Example - IncidentIo.UsersV2.list/2","doc":"IncidentIo.UsersV2.list(client)\n\n    IncidentIo.UsersV2.list(client, email: \"some-user@your-company.tld\")\n\nMore information at: https://api-docs.incident.io/tag/Users-V2#operation/Users%20V2_List","ref":"IncidentIo.UsersV2.html#list/2-example"},{"type":"function","title":"IncidentIo.UsersV2.show/2","doc":"Get a single user.","ref":"IncidentIo.UsersV2.html#show/2"},{"type":"function","title":"Example - IncidentIo.UsersV2.show/2","doc":"IncidentIo.UsersV2.show(client, \"some-user-id\")\n\nMore information at: https://api-docs.incident.io/tag/Users-V2#operation/Users%20V2_Show","ref":"IncidentIo.UsersV2.html#show/2-example"},{"type":"module","title":"IncidentIo.WorkflowsV2","doc":"Manage workflows.\n\nWorkflows allow you to automate certain actions and behaviors based on\nspecific triggers.","ref":"IncidentIo.WorkflowsV2.html"},{"type":"function","title":"IncidentIo.WorkflowsV2.create/2","doc":"Create a new workflow.\n\nWorkflow body example:\n```elixir\n%{\n  annotations: %{\n    \"incident.io/terraform/version\": \"3.0.0\"\n  },\n  condition_groups: [\n    %{\n      conditions: [\n        %{\n          operation: \"one_of\",\n          param_bindings: [\n            %{\n              array_value: [\n                %{\n                  literal: \"SEV123\",\n                  reference: \"incident.severity\"\n                }\n              ],\n              value: %{\n                literal: \"SEV123\",\n                reference: \"incident.severity\"\n              }\n            }\n          ],\n          subject: \"incident.severity\"\n        }\n      ]\n    }\n  ],\n  continue_on_step_error: true,\n  delay: %{\n    conditions_apply_over_delay: false,\n    for_seconds: 60\n  },\n  expressions: [\n    %{\n      else_branch: %{\n        result: %{\n          array_value: [\n            %{\n              literal: \"SEV123\",\n              reference: \"incident.severity\"\n            }\n          ],\n          value: %{\n            literal: \"SEV123\",\n            reference: \"incident.severity\"\n          }\n        }\n      },\n      label: \"Team Slack channel\",\n      operations: [\n        %{\n          branches: %{\n            branches: [\n              %{\n                condition_groups: [\n                  %{\n                    conditions: [\n                      %{\n                        operation: \"one_of\",\n                        param_bindings: [\n                          %{\n                            array_value: [\n                              %{\n                                literal: \"SEV123\",\n                                reference: \"incident.severity\"\n                              }\n                            ],\n                            value: %{\n                              literal: \"SEV123\",\n                              reference: \"incident.severity\"\n                            }\n                          }\n                        ],\n                        subject: \"incident.severity\"\n                      }\n                    ]\n                  }\n                ],\n                result: %{\n                  array_value: [\n                    %{\n                      literal: \"SEV123\",\n                      reference: \"incident.severity\"\n                    }\n                  ],\n                  value: %{\n                    literal: \"SEV123\",\n                    reference: \"incident.severity\"\n                  }\n                }\n              }\n            ],\n            returns: %{\n              array: true,\n              type: \"IncidentStatus\"\n            }\n          },\n          filter: %{\n            condition_groups: [\n              %{\n                conditions: [\n                  %{\n                    operation: \"one_of\",\n                    param_bindings: [\n                      %{\n                        array_value: [\n                          %{\n                            literal: \"SEV123\",\n                            reference: \"incident.severity\"\n                          }\n                        ],\n                        value: %{\n                          literal: \"SEV123\",\n                          reference: \"incident.severity\"\n                        }\n                      }\n                    ],\n                    subject: \"incident.severity\"\n                  }\n                ]\n              }\n            ]\n          },\n          navigate: %{\n            reference: \"catalog_attribute[\"01FCNDV6P870EA6S7TK1DSYD5H\"]\"\n          },\n          operation_type: \"navigate\",\n          parse: %{\n            returns: %{\n              array: true,\n              type: \"IncidentStatus\"\n            },\n            source: \"metadata.annotations[\"github.com/repo\"]\"\n          }\n        }\n      ],\n      reference: \"abc123\",\n      root_reference: \"incident.status\"\n    }\n  ],\n  folder: \"My folder 01\",\n  include_private_incidents: true,\n  name: \"My workflow\",\n  once_for: [\n    \"incident.url\"\n  ],\n  runs_on_incident_modes: [\n    \"standard\",\n    \"retrospective\"\n  ],\n  runs_on_incidents: \"newly_created\",\n  state: \"active\",\n  steps: [\n    %{\n      for_each: \"abc123\",\n      id: \"abc123\",\n      name: \"pagerduty.escalate\",\n      param_bindings: [\n        %{\n          array_value: [\n            %{\n              literal: \"SEV123\",\n              reference: \"incident.severity\"\n            }\n          ],\n          value: %{\n            literal: \"SEV123\",\n            reference: \"incident.severity\"\n          }\n        }\n      ]\n    }\n  ],\n  trigger: \"incident.updated\"\n}\n```","ref":"IncidentIo.WorkflowsV2.html#create/2"},{"type":"function","title":"Example - IncidentIo.WorkflowsV2.create/2","doc":"IncidentIo.WorkflowsV2.create(client, body)\n\nMore information at: https://api-docs.incident.io/tag/Workflows-V2#operation/Workflows%20V2_Create","ref":"IncidentIo.WorkflowsV2.html#create/2-example"},{"type":"function","title":"IncidentIo.WorkflowsV2.destroy/2","doc":"Archive an existing workflow.","ref":"IncidentIo.WorkflowsV2.html#destroy/2"},{"type":"function","title":"Example - IncidentIo.WorkflowsV2.destroy/2","doc":"IncidentIo.WorkflowsV2.destroy(client, \"some-workflow-id\")\n\nMore information at: https://api-docs.incident.io/tag/Workflows-V2#operation/Workflows%20V2_Delete","ref":"IncidentIo.WorkflowsV2.html#destroy/2-example"},{"type":"function","title":"IncidentIo.WorkflowsV2.list/1","doc":"List all workflows for an organisation.","ref":"IncidentIo.WorkflowsV2.html#list/1"},{"type":"function","title":"Example - IncidentIo.WorkflowsV2.list/1","doc":"IncidentIo.WorkflowsV2.list(client)\n\nMore information at: https://api-docs.incident.io/tag/Workflows-V2#operation/Workflows%20V2_List","ref":"IncidentIo.WorkflowsV2.html#list/1-example"},{"type":"function","title":"IncidentIo.WorkflowsV2.show/2","doc":"Get a single workflow.","ref":"IncidentIo.WorkflowsV2.html#show/2"},{"type":"function","title":"Example - IncidentIo.WorkflowsV2.show/2","doc":"IncidentIo.WorkflowsV2.show(client, \"some-workflow-id\")\n\nMore information at: https://api-docs.incident.io/tag/Workflows-V2#operation/Workflows%20V2_Show","ref":"IncidentIo.WorkflowsV2.html#show/2-example"},{"type":"function","title":"IncidentIo.WorkflowsV2.update/3","doc":"Update an existing workflow.\n\nWorkflow body example:\n```elixir\n%{\n  annotations: %{\n    \"incident.io/terraform/version\": \"3.0.0\"\n  },\n  condition_groups: [\n    %{\n      conditions: [\n        %{\n          operation: \"one_of\",\n          param_bindings: [\n            %{\n              array_value: [\n                %{\n                  literal: \"SEV123\",\n                  reference: \"incident.severity\"\n                }\n              ],\n              value: %{\n                literal: \"SEV123\",\n                reference: \"incident.severity\"\n              }\n            }\n          ],\n          subject: \"incident.severity\"\n        }\n      ]\n    }\n  ],\n  continue_on_step_error: true,\n  delay: %{\n    conditions_apply_over_delay: false,\n    for_seconds: 60\n  },\n  expressions: [\n    %{\n      else_branch: %{\n        result: %{\n          array_value: [\n            %{\n              literal: \"SEV123\",\n              reference: \"incident.severity\"\n            }\n          ],\n          value: %{\n            literal: \"SEV123\",\n            reference: \"incident.severity\"\n          }\n        }\n      },\n      label: \"Team Slack channel\",\n      operations: [\n        %{\n          branches: %{\n            branches: [\n              %{\n                condition_groups: [\n                  %{\n                    conditions: [\n                      %{\n                        operation: \"one_of\",\n                        param_bindings: [\n                          %{\n                            array_value: [\n                              %{\n                                literal: \"SEV123\",\n                                reference: \"incident.severity\"\n                              }\n                            ],\n                            value: %{\n                              literal: \"SEV123\",\n                              reference: \"incident.severity\"\n                            }\n                          }\n                        ],\n                        subject: \"incident.severity\"\n                      }\n                    ]\n                  }\n                ],\n                result: %{\n                  array_value: [\n                    %{\n                      literal: \"SEV123\",\n                      reference: \"incident.severity\"\n                    }\n                  ],\n                  value: %{\n                    literal: \"SEV123\",\n                    reference: \"incident.severity\"\n                  }\n                }\n              }\n            ],\n            returns: %{\n              array: true,\n              type: \"IncidentStatus\"\n            }\n          },\n          filter: %{\n            condition_groups: [\n              %{\n                conditions: [\n                  %{\n                    operation: \"one_of\",\n                    param_bindings: [\n                      %{\n                        array_value: [\n                          %{\n                            literal: \"SEV123\",\n                            reference: \"incident.severity\"\n                          }\n                        ],\n                        value: %{\n                          literal: \"SEV123\",\n                          reference: \"incident.severity\"\n                        }\n                      }\n                    ],\n                    subject: \"incident.severity\"\n                  }\n                ]\n              }\n            ]\n          },\n          navigate: %{\n            reference: \"catalog_attribute[\"01FCNDV6P870EA6S7TK1DSYD5H\"]\"\n          },\n          operation_type: \"navigate\",\n          parse: %{\n            returns: %{\n              array: true,\n              type: \"IncidentStatus\"\n            },\n            source: \"metadata.annotations[\"github.com/repo\"]\"\n          }\n        }\n      ],\n      reference: \"abc123\",\n      root_reference: \"incident.status\"\n    }\n  ],\n  folder: \"My folder 01\",\n  include_private_incidents: true,\n  name: \"My workflow\",\n  once_for: [\n    \"incident.url\"\n  ],\n  runs_on_incident_modes: [\n    \"standard\",\n    \"retrospective\"\n  ],\n  runs_on_incidents: \"newly_created\",\n  state: \"active\",\n  steps: [\n    %{\n      for_each: \"abc123\",\n      id: \"abc123\",\n      name: \"pagerduty.escalate\",\n      param_bindings: [\n        %{\n          array_value: [\n            %{\n              literal: \"SEV123\",\n              reference: \"incident.severity\"\n            }\n          ],\n          value: %{\n            literal: \"SEV123\",\n            reference: \"incident.severity\"\n          }\n        }\n      ]\n    }\n  ],\n  trigger: \"incident.updated\"\n}\n```","ref":"IncidentIo.WorkflowsV2.html#update/3"},{"type":"function","title":"Example - IncidentIo.WorkflowsV2.update/3","doc":"IncidentIo.WorkflowsV2.update(client, \"some-workflow-id\", body)\n\nMore information at: https://api-docs.incident.io/tag/Workflows-V2#operation/Workflows%20V2_Update","ref":"IncidentIo.WorkflowsV2.html#update/3-example"},{"type":"extras","title":"Changelog","doc":"# Changelog for IncidentIo v0.1.0\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/).\n\n## [Unreleased](https://github.com/sgerrand/ex_incident_io/tree/main)\n\n## [0.1.0](https://github.com/sgerrand/ex_incident_io/tree/v0.1.0) - 2024-07-03\n\n- Initial release","ref":"changelog.html"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2024 Sasha Gerrand\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# incident_io\n\n[![Build Status](https://github.com/sgerrand/ex_incident_io/actions/workflows/ci.yml/badge.svg?branch=main)](https://github.com/sgerrand/ex_incident_io/actions/workflows/ci.yml)\n[![Coverage Status](https://coveralls.io/repos/github/sgerrand/ex_incident_io/badge.svg?branch=main)](https://coveralls.io/github/sgerrand/ex_incident_io?branch=main)\n[![Hex.pm](https://img.shields.io/hexpm/v/incident_io.svg)](https://hex.pm/packages/incident_io)\n[![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/incident_io/)\n\nAn Elixir client for the [incident.io API](https://api-docs.incident.io/).\n\nWith just a few lines of code you can begin interacting:\n\n```elixir\nMix.install([\n  {:incident_io, \"~> 0.1\"}\n])\n\nclient = IncidentIo.Client.new(%{api_key: System.fetch_env!(\"INCIDENT_API_KEY\")\nIncidentIo.IncidentsV2.create(client, idempotency_key: \"you-idempotency-key\", visibility: :public)\n```","ref":"readme.html"},{"type":"extras","title":"Requirements - Overview","doc":"You'll need an [incident.io](https://incident.io/) account to use this package.\n[Sign up on their website](https://incident.io/) if you don't already have one.","ref":"readme.html#requirements"},{"type":"extras","title":"Installation - Overview","doc":"Add `:incident_io` to the dependencies in your project's `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:incident_io, \"~> 0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Getting started - Overview","doc":"You will need to create an API key via your [incident.io\ndashboard](https://app.incident.io/settings/api-keys) to make requests. Please\nnote their warning message about the scope for this API key:\n\n> When you create the key, you'll be able to choose what actions it can take for\n> your account: choose carefully, as those roles can only be set when you first\n> create the key.\n\nOnce you've created an API key then you're ready to start making requests.","ref":"readme.html#getting-started"},{"type":"extras","title":"Example - Overview","doc":"Assuming that you've created and configured your incident.io API key as an\nenvironment variable named `INCIDENT_API_KEY`, you can\ncreate and read incidents as simply as the following example module:\n\n```elixir\ndefmodule MyIncidentIo do\n  use IncidentIo\n\n  alias IncidentIo.Client\n  alias IncidentIo.IncidentsV2\n\n  def create(idempotency_key)\n    IncidentsV2.create(client, idempotency_key: idempotency_key, visibility: :public)\n  end\n\n  def read(incident_id)\n    IncidentsV2.show(client, incident_id)\n  end\n\n  defp client\n    Client.new(%{api_key: System.fetch_env!(\"INCIDENT_API_KEY\")\n  end\nend\n```","ref":"readme.html#example"},{"type":"extras","title":"Development - Overview","doc":"To start working on this application, clone the repository and fetch its\ndependencies:\n```shell\ngit clone https://github.com/sgerrand/ex_incident_io.git\ncd ex_incident_io\nmix deps.get\n```\n\nThen you can start running the tests.\n```shell\nmix test\n```","ref":"readme.html#development"},{"type":"extras","title":"Contributing - Overview","doc":"[Bug reports](https://github.com/sgerrand/ex_incident_io/issues) and [pull requests](https://github.com/sgerrand/ex_incident_io/pulls) are welcomed.","ref":"readme.html#contributing"},{"type":"extras","title":"License - Overview","doc":"This package is available as open source under the terms of the [MIT\nLicense](https://opensource.org/licenses/MIT).","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}